#
# Flood Fill - recursive
#

import ui
from PIL import Image

fname = "barba1.png"
image = Image.open(fname)

def neighbors(im, p):
  size = im.size
  n = []
  for dx,dy in [(-1,0),(1,0),(0,-1),(0,1)]:
    x = p[0] + dx
    y = p[1] + dy
    if 0 <= x < size[0] and 0 <= y < size[1]:
      n.append((x, y))
  return n
  
# --------------------------------------------------------------------

def flood_rec(im, p, oldCol, newCol):
  im.putpixel(p, newCol)
  for q in neighbors(im, p):
    if im.getpixel(q) == oldCol:
      flood_rec(im, q, oldCol, newCol)
  
def flood(im, p, color):
  oldCol = im.getpixel(p)
  if oldCol == color:
    return
  flood_rec(im, p, oldCol, color)

# --------------------------------------------------------------------

def clicked(x, y):
  flood(image, (x, y), (255, 0, 0))
  ui.update(image)

ui.UI(image, "Flood recursive", clicked)
