#
# Flood Fill - Stack
#

import ui
from PIL import Image
from liststack import Stack

fname = "barba1.png"
image = Image.open(fname)

def neighbors(im, p):
  size = im.size
  n = []
  for dx,dy in [(-1,0),(1,0),(0,-1),(0,1)]:
    x = p[0] + dx
    y = p[1] + dy
    if 0 <= x < size[0] and 0 <= y < size[1]:
      n.append((x, y))
  return n

# --------------------------------------------------------------------
  
def flood(im, p, color):
  oldCol = im.getpixel(p)
  if oldCol == color:
    return
  A = Stack()
  im.putpixel(p, color)
  A.push(p)
  while not A.is_empty():
    q = A.pop()
    for r in neighbors(im, q):
      if im.getpixel(r) == oldCol:
        im.putpixel(r, color)
        A.push(r)
        
# --------------------------------------------------------------------

def clicked(x, y):
  flood(image, (x, y), (255, 0, 0))
  ui.update(image)

ui.UI(image, "Flood w/stack", clicked)
