#
# UI for Flood Fill
#

import tkinter as _Tkinter
from PIL import ImageTk as _ImageTk
import sys as _sys

_root = None
_image = None
_tkpi = None
_clicked = None

_factor = 4

# --------------------------------------------------------------------

def _window_closed():
  _root.destroy()
  _sys.exit(9)

def update(image):
  global _image
  global _tkpi
  _image = image.resize((_factor * image.size[0], _factor * image.size[1]))
  _tkpi.paste(_image)
  _root.update()
  
def UI(image, title, clicked):
  global _root
  global _image
  global _tkpi
  global _clicked
  assert(_root is None)
  _clicked = clicked
  _image = image.resize((_factor * image.size[0], _factor * image.size[1]))
  _root = _Tkinter.Tk()
  _root.geometry('%dx%d' % _image.size)
  _root.title(title)
  _root.bind("<Button>", lambda ev: _clicked(ev.x // _factor, ev.y // _factor))
  _root.bind("<Return>", lambda ev: _root.quit())
  _root.protocol("WM_DELETE_WINDOW", _window_closed)
  _tkpi = _ImageTk.PhotoImage(_image)
  _label = _Tkinter.Label(_root, image=_tkpi)
  _label.place(x=0, y=0, width=_image.size[0], height=_image.size[1])
  _root.mainloop()

# --------------------------------------------------------------------
